float decayA = 3.0; //Turing 12.0
float decayB = 9.0; //Turing 16.0
float alphaArr[] = new float[w*h];
float betaArr[] = new float[w*h];

float gamma = .0004;

float p1=.08;
float p2=.08;
float p3=.12;
float p4=.03;
float p5=.1;
float p6=.15;
float p7 =.05;
float pMax = .5;

//grey scott
//k = .4 to .65
//F = .1 to .65
//values between 0 and 1
double reactionAGS(double aVal, double bVal, int i) {
  return reactionRate*(-aVal*bVal*bVal+Farr[i]*(1-aVal));
}

double reactionBGS(double aVal, double bVal, int i) {
  return reactionRate*(aVal*bVal*bVal-(Farr[i]+karr[i])*bVal);
}

//FitzHugh-Nagumo
double reactionAFHN(double aVal, double bVal, int i) {
  return reactionRate*(aVal-aVal*aVal*aVal-bVal+karr[i]);
}

double reactionBFHN(double aVal, double bVal, int i) {
  return reactionRate*Farr[i]*(aVal-bVal);
}

//BRUSSELATOR
//alpha ~3 beta ~9
//rate .5-2
//dA 12.6/47.5 - 16.7/49.4
//dB 27.5/141.5 - 36.4/117.6
//a ~ 3 b ~ 3
double reactionABrussel(double aVal, double bVal, int i) {
  return reactionRate*(alphaArr[i]-(1+betaArr[i])*aVal+aVal*aVal*bVal);
}

double reactionBBrussel(double aVal, double bVal, int i) {
  return reactionRate*(betaArr[i]*aVal-aVal*aVal*bVal);
}


double reactionAT(double aVal, double bVal, int i) {
  return reactionRate*(aVal*bVal-aVal-decayA);
}

double reactionBT(double aVal, double bVal, int i) {
  return reactionRate*(decayB-aVal*bVal);
}

//Oregonator
// k = .0000762
// F = 1.0
//dB > dA
double epsilon = .0099;
double reactionAOregon(double aVal, double bVal, int i) {
  return (aVal*(1-aVal)-F*bVal*(aVal-k)/(k+aVal))/epsilon;
}

double reactionBOregon(double aVal, double bVal, int i) {
  return aVal-bVal;
}


//Gierer-Meinhardt
//dB > dA
//decay A | decay B ~ .001-.005
//epsilon ~ .0001
double reactionAGM(double aVal, double bVal, int i) {
  return reactionRate*(epsilon+aVal*aVal/bVal-decayA*aVal);
}

double reactionBGM(double aVal, double bVal, int i) {
  return reactionRate*(aVal*aVal-decayB*bVal);
}

//p1 = .05-.13
//p2 = .035-.08
//p3 = .04-.5
//p4 = .04-.1
//p5 = .05-.11
//p6 = .15-.48
double reactionAKondo(double aVal, double bVal, int i) {
  return reactionRate*(constrain(p1*aVal-p2*bVal+p3,0,pMax)-p4*aVal);
}

double reactionBKondo(double aVal, double bVal, int i) {
  return reactionRate*(constrain(p5*aVal-p6,0,pMax)-p5*bVal);
}

double constrain(double val, double min, double max) {
  if(val < min) return min;
  else if(val > max) return max;
  else return val;
}

void setupFK() {
  int index = 0;
  for(int i=0;i<w;++i) {
    for(int j=0;j<h;++j) {
      karr[index] = -.05;//j*1.0/h*.21 -.2;
      Farr[index] = 10;//i*1.0/w*20 +.1;
      index++;
    }
  }
}

void setupAB() {
  int index = 0;
  for(int i=0;i<w;++i) {
    for(int j=0;j<h;++j) {
      alphaArr[index] = j*1.0/h*0+4.5;
      betaArr[index] = i*1.0/w*0+3;
      index++;
    }
  }
}
