float decayA = 12.0; //Turing 12.0
float decayB = 16.0; //Turing 16.0

float gamma = .0004;


//grey scott
//k = .4 to .65
//F = .1 to .65
//values between 0 and 1
double reactionAGS(double aVal, double bVal, int i) {
  return reactionRate*(-aVal*bVal*bVal+F*(1-aVal));
}

double reactionBGS(double aVal, double bVal, int i) {
  return reactionRate*(aVal*bVal*bVal-(F+k)*bVal);
}

//FitzHugh-Nagumo
double reactionAFHN(double aVal, double bVal, int i) {
  return reactionRate*(aVal-aVal*aVal*aVal-bVal);
}

double reactionBFHN(double aVal, double bVal, int i) {
  return reactionRate*.06*(aVal-0.0*bVal-.04);
}

//BRUSSELATOR
//alpha ~3 beta ~9
//rate .5-2
//dA 12.6/47.5 - 16.7/49.4
//dB 27.5/141.5 - 36.4/117.6
//a ~ 3 b ~ 3
double reactionABrussel(double aVal, double bVal, int i, int j) {
  return reactionRate*(decayA-(1+decayB)*aVal+aVal*aVal*bVal);
}

double reactionBBrussel(double aVal, double bVal, int i, int j) {
  return reactionRate*(decayB*aVal-aVal*aVal*bVal);
}


double reactionAT(double aVal, double bVal, int i, int j) {
  return reactionRate*(aVal*bVal-aVal-decayA);
}

double reactionBT(double aVal, double bVal, int i, int j) {
  return reactionRate*(decayB-aVal*bVal);
}

//Oregonator
// k = .0000762
// F = 1.0
//dB > dA
double epsilon = .0099;
double reactionAOregon(double aVal, double bVal, int i, int j) {
  return (aVal*(1-aVal)-F*bVal*(aVal-k)/(k+aVal))/epsilon;
}

double reactionBOregon(double aVal, double bVal, int i, int j) {
  return aVal-bVal;
}


//Gierer-Meinhardt
//dB > dA
//decay A | decay B ~ .001-.005
//epsilon ~ .0001
double reactionAGM(double aVal, double bVal, int i, int j) {
  return reactionRate*(epsilon+aVal*aVal/bVal-decayA*aVal);
}

double reactionBGM(double aVal, double bVal, int i, int j) {
  return reactionRate*(aVal*aVal-decayB*bVal);
}

void setupFK() {
  int index = 0;
  for(int i=0;i<w;++i) {
    for(int j=0;j<h;++j) {
      Farr[index] = j*1.0/h*.085;
      karr[index] = i*1.0/w*.04+.03;
      index++;
    }
  }
}
