void glSetup() {
  gl = ((PGraphicsOpenGL) g).beginGL(); 
  glu = new GLU();
  //glut = new GLUT();
  gl.glShadeModel ( GL.GL_SMOOTH );
  gl.glClearColor (1.0,1.0,1.0,1.0); 
  gl.glEnable(GL.GL_DEPTH_TEST);
  gl.glEnable(GL.GL_BLEND);
  gl.glEnable(GL.GL_COLOR_MATERIAL);
  gl.glEnable(GL.GL_POINT_SMOOTH);	
  gl.glColorMaterial(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT_AND_DIFFUSE);
  gl.glHint(GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);  
    //glu.gluPerspective(50.0, 1.0, 5.0, 1500.0); //50
  //((PGraphicsOpenGL) g).endGL(); 
  //gl.glEnable(GL.GL_CULL_FACE);
  //gl.glCullFace(GL.GL_BACK);
  gl.glLightModeli(GL.GL_LIGHT_MODEL_TWO_SIDE, GL.GL_TRUE);
}


void glStart() {
  gl = ((PGraphicsOpenGL) g).beginGL(); 
  gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
}

void glSetMaterials() { 
  gl.glDisable(GL.GL_COLOR_MATERIAL);	
  //gl.glColorMaterial(GL.GL_FRONT_AND_BACK, GL.GL_DIFFUSE);
  gl.glColor3f(.6,.6,.6);
   
  float mat_specular[] = {1,1,1,1.0}; 
  gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SPECULAR, mat_specular,0); //specular reflection, defines effect mat has on the reflected light
  
  float mat_shininess[] = {20};
  gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SHININESS, mat_shininess,0);  //specular exponent (shininess), control the size and brightness of the specular reflection
  
  float mat_diffuseb[] = {.6,.6,.6,1.0};
  gl.glMaterialfv(GL.GL_FRONT, GL.GL_DIFFUSE, mat_diffuseb,0);
  
  float mat_diffuse[] = {1,1,0,1.0}; 
  gl.glMaterialfv(GL.GL_BACK, GL.GL_DIFFUSE, mat_diffuse,0);

}

void glSetLights() {
  gl.glEnable ( GL.GL_LIGHTING );  
  float light0_diffuse[] = {.7,.7,.7,1};
  gl.glLightfv(gl.GL_LIGHT0, gl.GL_DIFFUSE,  light0_diffuse,0);
  gl.glEnable ( GL.GL_LIGHT0 );
}

