int levels = 4;

FlexCompRowMatrix[] interp = new FlexCompRowMatrix[levels-1];
FlexCompRowMatrix[] restrict = new FlexCompRowMatrix[levels-1];

//matrix stuff
void computeLaplacian() {
  LA.zero();
  LB.zero();
  int index = 0;
  int iX1,iX0,iY1,iY0,iZ1,iZ0;
  float dTdX = deltaT/delxSq;
  for(int x=0;x<w;++x) {
    for(int y=0;y<h;++y) {
      for(int z=0;z<d;++z) {
       index = xyzToIndex(x,y,z);
       iX1 = xyzToIndex(iNext[x],y,z); iX0 = xyzToIndex(iPrev[x],y,z);
       iY1 = xyzToIndex(x,jNext[y],z); iY0 = xyzToIndex(x,jPrev[y],z);
       iZ1 = xyzToIndex(x,y,kNext[z]); iZ0 = xyzToIndex(x,y,kPrev[z]);
       //EULER IMPLICIT
       /*
       LA.add(index, iX1,-dTdX*aRateX);
       LA.add(index, iX0,-dTdX*aRateX);
       LA.add(index, iY1,-dTdX*aRateY);
       LA.add(index, iY0,-dTdX*aRateY);
       LA.add(index, iZ1,-dTdX*(aRateZ+z*.02/h));
       LA.add(index, iZ0,-dTdX*(aRateZ+z*.02/h));
       LA.add(index, index,1+2*dTdX*(aRateX+aRateY+aRateZ+z*.02/h));

       LB.add(index,iX1,-dTdX*bRate);
       LB.add(index,iX0,-dTdX*bRate);
       LB.add(index,iY1,-dTdX*bRate);
       LB.add(index,iY0,-dTdX*bRate);
       LB.add(index,iZ1,-dTdX*bRate);
       LB.add(index,iZ0,-dTdX*bRate);
       LB.add(index,index,1+6*dTdX*bRate);
       */
       
       //Forward euler
       
       LA.add(index, iX1,dTdX*aRateX);
       LA.add(index, iX0,dTdX*aRateX);
       LA.add(index, iY1,dTdX*aRateY);
       LA.add(index, iY0,dTdX*aRateY);
       LA.add(index, iZ1,dTdX*(aRateZ));
       LA.add(index, iZ0,dTdX*(aRateZ));
       LA.add(index, index,-2*dTdX*(aRateX+aRateY+aRateZ));

       LB.add(index,iX1,dTdX*bRate);
       LB.add(index,iX0,dTdX*bRate);
       LB.add(index,iY1,dTdX*bRate);
       LB.add(index,iY0,dTdX*bRate);
       LB.add(index,iZ1,dTdX*bRate);
       LB.add(index,iZ0,dTdX*bRate);
       LB.add(index,index,-6*dTdX*bRate);       
       
      }
    }
  }
  //LA = new CompRowMatrix(LA);
  //LB = new CompRowMatrix(LB);
  //identity minus these matrices for implicit solver.
  ((FlexCompRowMatrix)LA).compact();
  ((FlexCompRowMatrix)LB).compact();
  /*
  Preconditioner preA = new DiagonalPreconditioner(w*h*d);
  Preconditioner preB = new DiagonalPreconditioner(w*h*d);
  preA.setMatrix(LA);
  preB.setMatrix(LB);
  solverA.setPreconditioner(preA);
  solverB.setPreconditioner(preB);
  solverA.setIterationMonitor(new DefaultIterationMonitor(100,.01,.0001,10000));
  solverB.setIterationMonitor(new DefaultIterationMonitor(100,.01,.0001,10000));
  */
}

int xyzToIndex(int x, int y, int z) {
  return z+y*d+x*d*h;
}

int xyzToIndex(int x, int y, int z, int cw, int ch, int cd) {
  return z+y*cd+x*cd*ch;
}


int[] indexToxyz(int index) {
  int[] xyz = new int[3];
  xyz[0] = index/(d*h);
  index = index%(d*h);
  xyz[1] = index/d;
  xyz[2] = index-xyz[1];
  return xyz;
}

void tricubicInterp(DenseVector course, DenseVector fine) {
  
}

void trilinearInterp(DenseVector course, DenseVector fine, int h) {
  int index = 0;
  int div2 = int(pow(2,h));
  int cw = w/div2;
  int ch = h/div2;
  int cd = d/div2;
  double curr;
  int index2;
  for(int x = 0;x<cw;++x) {
    for(int y = 0;y<ch;++y) {
      for(int z = 0;z<cd;++z) {
        curr = course.get(index);
        index2 = xyzToIndex(2*x,2*y,2*z,2*cw,2*ch,2*cd);
        index++;
      }
    }
  }
}

void gaussSeidel(FlexCompRowMatrix M, DenseVector v, DenseVector b) {
  int numRows = M.numRows();
  SparseVector curr;
  double diag;
  for(int i=0;i<numRows;++i) {
    curr = M.getRow(i);
    diag = curr.get(i);
    //v.set(i,M.getRow(i).dot(v));
    v.add(i,(b.get(i)-curr.dot(v))/diag);
  }
  
  /*
  MatrixEntry ent;
  int pRow = 0;
  int cRow, cCol;
  double diag = 0;
  double temp = 0;
  for(Iterator it = M.iterator();it.hasNext();) {
    ent = (MatrixEntry) it.next();
    cRow = ent.row();
    cCol = ent.column();
    if(pRow != cRow) {
      v.set(pRow, (b.get(pRow)-temp)/diag);
      temp = 0;
      pRow = cRow;
    }
    if(cRow != cCol)
      temp += v.get(cCol)*ent.get();
    else
      diag = ent.get();
  }
  */
}

