float decayA = 12.0; //Turing 12.0
float decayB = 16.0; //Turing 16.0

float gamma = .0004;


//grey scott
//k = .4 to .65
//F = .1 to .65
//values between 0 and 1
double reactionAGS(double aVal, double bVal) {
  return reactionRate*(-aVal*bVal*bVal+F*(1-aVal));
}

double reactionBGS(double aVal, double bVal) {
  return reactionRate*(aVal*bVal*bVal-(F+k)*bVal);
}

//FitzHugh-Nagumo
float reactionAFHN(float aVal, float bVal, int i, int j) {
  return reactionRate*(aVal-aVal*aVal*aVal-bVal-.05);
}

float reactionBFHN(float aVal, float bVal, int i, int j) {
  return reactionRate*10.0*(aVal-bVal);
}

//BRUSSELATOR
float reactionABrussel(float aVal, float bVal, int i, int j) {
  return reactionRate*(decayA-(1+decayB)*aVal+aVal*aVal*bVal);
}

float reactionBBrussel(float aVal, float bVal, int i, int j) {
  return reactionRate*(decayB*aVal-aVal*aVal*bVal);
}


