//matrix stuff
void computeLaplacian() {
  LA.zero();
  LB.zero();
  int index = 0;
  int iX1,iX0,iY1,iY0,iZ1,iZ0;
  float dTdX = deltaT/delxSq;
  for(int x=0;x<w;++x) {
    for(int y=0;y<h;++y) {
      for(int z=0;z<d;++z) {
       index = xyzToIndex(x,y,z);
       iX1 = xyzToIndex(iNext[x],y,z); iX0 = xyzToIndex(iPrev[x],y,z);
       iY1 = xyzToIndex(x,jNext[y],z); iY0 = xyzToIndex(x,jPrev[y],z);
       iZ1 = xyzToIndex(x,y,kNext[z]); iZ0 = xyzToIndex(x,y,kPrev[z]);
       //EULER IMPLICIT
       /*
       LA.add(index, iX1,-dTdX*aRateX);
       LA.add(index, iX0,-dTdX*aRateX);
       LA.add(index, iY1,-dTdX*aRateY);
       LA.add(index, iY0,-dTdX*aRateY);
       LA.add(index, iZ1,-dTdX*(aRateZ+z*.02/h));
       LA.add(index, iZ0,-dTdX*(aRateZ+z*.02/h));
       LA.add(index, index,1+2*dTdX*(aRateX+aRateY+aRateZ+z*.02/h));

       LB.add(index,iX1,-dTdX*bRate);
       LB.add(index,iX0,-dTdX*bRate);
       LB.add(index,iY1,-dTdX*bRate);
       LB.add(index,iY0,-dTdX*bRate);
       LB.add(index,iZ1,-dTdX*bRate);
       LB.add(index,iZ0,-dTdX*bRate);
       LB.add(index,index,1+6*dTdX*bRate);
       */
       
       //Forward euler
       
       LA.add(index, iX1,dTdX*aRateX);
       LA.add(index, iX0,dTdX*aRateX);
       LA.add(index, iY1,dTdX*aRateY);
       LA.add(index, iY0,dTdX*aRateY);
       LA.add(index, iZ1,dTdX*(aRateZ));
       LA.add(index, iZ0,dTdX*(aRateZ));
       LA.add(index, index,-2*dTdX*(aRateX+aRateY+aRateZ));

       LB.add(index,iX1,dTdX*bRate);
       LB.add(index,iX0,dTdX*bRate);
       LB.add(index,iY1,dTdX*bRate);
       LB.add(index,iY0,dTdX*bRate);
       LB.add(index,iZ1,dTdX*bRate);
       LB.add(index,iZ0,dTdX*bRate);
       LB.add(index,index,-6*dTdX*bRate);       
       
      }
    }
  }
  //LA = new CompRowMatrix(LA);
  //LB = new CompRowMatrix(LB);
  //identity minus these matrices for implicit solver.
  ((FlexCompRowMatrix)LA).compact();
  ((FlexCompRowMatrix)LB).compact();
  /*
  Preconditioner preA = new DiagonalPreconditioner(w*h*d);
  Preconditioner preB = new DiagonalPreconditioner(w*h*d);
  preA.setMatrix(LA);
  preB.setMatrix(LB);
  solverA.setPreconditioner(preA);
  solverB.setPreconditioner(preB);
  solverA.setIterationMonitor(new DefaultIterationMonitor(100,.01,.0001,10000));
  solverB.setIterationMonitor(new DefaultIterationMonitor(100,.01,.0001,10000));
  */
}

int xyzToIndex(int x, int y, int z) {
  return z+y*d+x*d*h;
}

int xyzToIndex(int x, int y, int z, int cw, int ch, int cd) {
  return z+y*cd+x*cd*ch;
}


int[] indexToxyz(int index) {
  int[] xyz = new int[3];
  xyz[0] = index/(d*h);
  index = index%(d*h);
  xyz[1] = index/d;
  xyz[2] = index-xyz[1];
  return xyz;
}

void gaussSeidel(FlexCompRowMatrix M, DenseVector v, DenseVector b) {
  int numRows = M.numRows();
  SparseVector curr;
  double diag;
  for(int i=0;i<numRows;++i) {
    curr = M.getRow(i);
    diag = curr.get(i);
    //v.set(i,M.getRow(i).dot(v));
    v.add(i,(b.get(i)-curr.dot(v))/diag);
  }
}

